HDU 4939 The Stupid Tower Defense (dp+思维构造)

Stupid Tower Defense

Time Limit: 12000/6000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)
Total Submission(s): 2442    Accepted Submission(s): 685


Problem Description
FSF is addicted to a stupid tower defense game. The goal of tower defense games is to try to stop enemies from crossing a map by building traps to slow them down and towers which shoot at them as they pass.

The map is a line, which has n unit length. We can build only one tower on each unit length. The enemy takes t seconds on each unit length. And there are 3 kinds of tower in this game: The red tower, the green tower and the blue tower.

The red tower damage on the enemy x points per second when he passes through the tower.

The green tower damage on the enemy y points per second after he passes through the tower.

The blue tower let the enemy go slower than before (that is, the enemy takes more z second to pass an unit length, also, after he passes through the tower.)

Of course, if you are already pass through m green towers, you should have got m*y damage per second. The same, if you are already pass through k blue towers, the enemy should have took t + k*z seconds every unit length.

FSF now wants to know the maximum damage the enemy can get.
 

Input
There are multiply test cases.

The first line contains an integer T (T<=100), indicates the number of cases.

Each test only contain 5 integers n, x, y, z, t (2<=n<=1500,0<=x, y, z<=60000,1<=t<=3)
 

Output
For each case, you should output "Case #C: " first, where C indicates the case number and counts from 1. Then output the answer. For each test only one line which have one integer, the answer to this question.
 

Sample Input
 
  
1 2 4 3 2 1
 

Sample Output
 
  
Case #1: 12
Hint
For the first sample, the first tower is blue tower, and the second is red tower. So, the total damage is 4*(1+2)=12 damage points.
 

Author
UESTC
 

Source
 

Recommend
We have carefully selected several similar problems for you:   6275  6274  6273  6272  6271 
#include <queue>
#include <iostream>
#include<cstring>
#include<stdio.h>
#include<math.h>
using namespace std;
#define maxn 1600
long long  dp[maxn][maxn];
long long  n,x,y,z,t;
long long ans;
/*
题意中y的伤害随时间的递增而递增,
而如何枚举模拟这种情况呢?
不能简单的靠数学技巧暴力破,
dp[i][j]表示前i个塔中有j个蓝塔的最大值,
贪心思想红塔全排在前面,
所以对于红塔的数量,只要对n-i进行计算即可.
*/
int main()
{
    ios::sync_with_stdio(false);
    int tt;cin>>tt;
    for(int ca=1;ca<=tt;ca++)
    {
        cin>>n>>x>>y>>z>>t;
        memset(dp,0,sizeof(dp));
        ans=n*t*x;
        for(int i=1;i<=n;i++)
        {
            for(int j=0;j<=i;j++)
            {
                if(!j)
                     dp[i][j]=dp[i-1][j]+(i-j-1)*y*t;//如果蓝灯的数量为零
                else
                    dp[i][j]=max(dp[i-1][j]+max(0,(i-j-1))*(j*z+t)*y,dp[i-1][j-1]+(i-j)*(j*z-z+t)*y);//
                ans=max( ans, dp[i][j] + (n-i)*(t+j*z)*(x+(i-j)*y ));
            }
        }
        cout<<"Case #"<<ca<<": "<<ans<<endl;
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/qq_37451344/article/details/80372361